
package sjl;

/**
 * <code>ArrayIteratorBoolean</code> creates a iterator 
 * abstraction around the builtin array of boolean[]
 * When <code>ArrayIteratorBoolean</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorBoolean extends Iter implements RandomIterator {
    boolean[] array;
    int pos;

    public ArrayIteratorBoolean(boolean[] arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorBoolean)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorBoolean)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorBoolean)i).pos;
    }

    public ArrayIteratorBoolean copy() {
	return new ArrayIteratorBoolean(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorBoolean(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorBoolean ii = (ArrayIteratorBoolean)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Boolean(array[pos]);
    }

    public Object get(int n)  {
	return new Boolean(array[pos + n]);
    }

    public Object put(Object o) {
	array[pos] = ((Boolean)o).booleanValue();
	return o;
    }

    public Object put(int n, Object o)  {
	array[pos + n] = ((Boolean)o).booleanValue();
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
