
package sjl;

/**
 * <code>ArrayIteratorByte</code> creates a iterator 
 * abstraction around the builtin array of byte[]
 * When <code>ArrayIteratorByte</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorByte extends Iter implements RandomIterator {
    byte[] array;
    int pos;

    public ArrayIteratorByte(byte[] arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorByte)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorByte)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorByte)i).pos;
    }

    public ArrayIteratorByte copy() {
	return new ArrayIteratorByte(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorByte(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorByte ii = (ArrayIteratorByte)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Integer(array[pos]);
    }

    public Object get(int n)  {
	return new Integer(array[pos + n]);
    }

    public Object put(Object o) {
	array[pos] = (byte)((Integer)o).intValue();
	return o;
    }

    public Object put(int n, Object o)  {
	array[pos + n] = (byte)((Integer)o).intValue();
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
