
package sjl;

/**
 * <code>ArrayIteratorCharacter</code> creates a iterator 
 * abstraction around the builtin array of char[]
 * When <code>ArrayIteratorCharacter</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorCharacter extends Iter implements RandomIterator {
    char[] array;
    int pos;

    public ArrayIteratorCharacter(char[] arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorCharacter)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorCharacter)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorCharacter)i).pos;
    }

    public ArrayIteratorCharacter copy() {
	return new ArrayIteratorCharacter(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorCharacter(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorCharacter ii = (ArrayIteratorCharacter)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Character(array[pos]);
    }

    public Object get(int n)  {
	return new Character(array[pos + n]);
    }

    public Object put(Object o) {
	array[pos] = ((Character)o).charValue();
	return o;
    }

    public Object put(int n, Object o)  {
	array[pos + n] = ((Character)o).charValue();
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
