
package sjl;

/**
 * <code>ArrayIteratorDouble</code> creates a iterator 
 * abstraction around the builtin array of double[]
 * When <code>ArrayIteratorDouble</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorDouble extends Iter implements RandomIterator {
    double[] array;
    int pos;

    public ArrayIteratorDouble(double[] arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorDouble)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorDouble)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorDouble)i).pos;
    }

    public ArrayIteratorDouble copy() {
	return new ArrayIteratorDouble(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorDouble(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorDouble ii = (ArrayIteratorDouble)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Double(array[pos]);
    }

    public Object get(int n)  {
	return new Double(array[pos + n]);
    }

    public Object put(Object o) {
	array[pos] = ((Double)o).doubleValue();
	return o;
    }

    public Object put(int n, Object o)  {
	array[pos + n] = ((Double)o).doubleValue();
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
