
package sjl;

/**
 * <code>ArrayIteratorFloat</code> creates a iterator 
 * abstraction around the builtin array of float[]
 * When <code>ArrayIteratorFloat</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorFloat extends Iter implements RandomIterator {
    float[] array;
    int pos;

    public ArrayIteratorFloat(float[] arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorFloat)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorFloat)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorFloat)i).pos;
    }

    public ArrayIteratorFloat copy() {
	return new ArrayIteratorFloat(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorFloat(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorFloat ii = (ArrayIteratorFloat)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Float(array[pos]);
    }

    public Object get(int n)  {
	return new Float(array[pos + n]);
    }

    public Object put(Object o) {
	array[pos] = ((Float)o).floatValue();
	return o;
    }

    public Object put(int n, Object o)  {
	array[pos + n] = ((Float)o).floatValue();
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
