
package sjl;

/**
 * <code>ArrayIteratorInteger</code> creates a iterator 
 * abstraction around the builtin array of int[]
 * When <code>ArrayIteratorInteger</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorInteger extends Iter implements RandomIterator {
    int[] array;
    int pos;

    public ArrayIteratorInteger(int[] arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorInteger)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorInteger)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorInteger)i).pos;
    }

    public ArrayIteratorInteger copy() {
	return new ArrayIteratorInteger(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorInteger(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorInteger ii = (ArrayIteratorInteger)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Integer(array[pos]);
    }

    public Object get(int n)  {
	return new Integer(array[pos + n]);
    }

    public Object put(Object o) {
	array[pos] = ((Integer)o).intValue();
	return o;
    }

    public Object put(int n, Object o)  {
	array[pos + n] = ((Integer)o).intValue();
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
