
package sjl;

/**
 * <code>ArrayIteratorString</code> creates a iterator 
 * abstraction around the builtin array of String
 * When <code>ArrayIteratorString</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorString extends Iter implements RandomIterator {
    String array;
    int pos;

    public ArrayIteratorString(String arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorString)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorString)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorString)i).pos;
    }

    public ArrayIteratorString copy() {
	return new ArrayIteratorString(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorString(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorString ii = (ArrayIteratorString)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Character(array.charAt(pos));
    }

    public Object get(int n)  {
	return new Character(array.charAt(pos + n));
    }

    public Object put(Object o) {
	return o;
    }

    public Object put(int n, Object o)  {
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
