
package sjl;

/**
 * <code>ArrayIteratorStringBuffer</code> creates a iterator 
 * abstraction around the builtin array of StringBuffer
 * When <code>ArrayIteratorStringBuffer</code> a java array can be adapted so it
 * can be used as a container in the same way al all other containers.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

class ArrayIteratorStringBuffer extends Iter implements RandomIterator {
    StringBuffer array;
    int pos;

    public ArrayIteratorStringBuffer(StringBuffer arr, int n) {
	array = arr;
	pos = n;
    }

    public int distance(Iterator i) {
	return ((ArrayIteratorStringBuffer)i).pos - pos;
    }

    public boolean cmp(Iterator i) {
	return pos == ((ArrayIteratorStringBuffer)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((ArrayIteratorStringBuffer)i).pos;
    }

    public ArrayIteratorStringBuffer copy() {
	return new ArrayIteratorStringBuffer(array, pos);
    }

    public Iterator genericCopy() {
	return new ArrayIteratorStringBuffer(array, pos);
    }

    public void setTo(Iterator i) {
        ArrayIteratorStringBuffer ii = (ArrayIteratorStringBuffer)i;
	array = ii.array;
	pos = ii.pos;
    }

    public Object get() {
	return new Character(array.charAt(pos));
    }

    public Object get(int n)  {
	return new Character(array.charAt(pos + n));
    }

    public Object put(Object o) {
	array.setCharAt(pos, ((Character)o).charValue());
	return o;
    }

    public Object put(int n, Object o)  {
	array.setCharAt(pos + n, ((Character)o).charValue());
	return o;
    }

    public Iterator next() {
	pos++;
	return this;
    }

    public Iterator prev() {
	pos--;
	return this;
    }

    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }
}
