package sjl;

/**
 * An interface for containers that support the <code>push_back()</code> method.
 * By implementing this interface, the container can be used with the
 * iterator adapter <code>BackInsertIterator</code>.
 * 
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 * 
 * @see BackInsertIterator
 * @see List
 * @see Deque
 * @see Vector
 */

public interface BackInsertContainer extends SequenceContainer {

    /**
     * Add an element to the end of the container.
     * @param object The element that will be added.
     */
    abstract void push_back(Object object);

    /**
     * Remove the last element in the container.
     */
    abstract void pop_back();
}
