package sjl;

/**
 * Defines the methods allowed on bidirectional iterators. Bidirectional 
 * iterators allow multiple passes over the container using both 
 * <code>next()</code> and <code>prev()</code>.
 *
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 *
 * @see List
 * @see Map
 * @see MultiMap
 * @see Set
 * @see MultiSet
 */
public interface BidirectionalIterator extends ForwardIterator {

    /**
     * Advance self to the previous element in the container.
     * @return self
     */
    public abstract Iterator prev();
}
