package sjl;

/**
 * A function adapter. The <code>Bind1stFunction</code> class can wrap a 
 * <code>Function2</code> class so that it appears as a <code>Function1</code>.
 * <pre>
 *
 *     Algo.transform(list.begin(), list.end(), list.begin()
 *               new Bind1stFunction(new FuncSumInteger(), new Integer(5)));
 * </pre>
 * The above example will add 5 to each integer in list.
 *
 * <p>Copyright <a href=..\Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */
public class Bind1stFunction implements Function1 {
    Function2 function;
    Object value;

    /**
     * Specified the function and the value to use.
     */
    public Bind1stFunction(Function2 func, Object val) {
	function = func;
	value = val;
    }

    /**
     * Call the specified function using value and the argument.
     */
    public Object perform(Object o)  {
	return function.perform(value, o);
    }
}
