package sjl;
import java.util.Enumeration;

/**
 * <code>EnumerationIterator</code> is an iterator adapter that turns a 
 * range of forward iterators into an <code>Enumeration</code>.
 *
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */
public class EnumerationIterator implements Enumeration {

    private ForwardIterator begin;
    private ForwardIterator end;
    /**
     * Contruct an Enumeration over the specified range.
     * @param first The beginning of the range.
     * @param last The end of the range.
     */
    public EnumerationIterator(ForwardIterator first, ForwardIterator last) {
   	begin = Iter.copy(first);
   	end = last;
    }

    /**
     * Returns true if the enumeration contains more elements; false
     * if its empty.
     */
    public boolean hasMoreElements() {
	return !begin.cmp(end);
    }

    /**
     * Returns the next element of the enumeration. Calls to this method
     * will enumerate successive elements.
     */
    public Object nextElement() {
	Object o = begin.get();
	begin.next();
	return o;
    }
}
