package sjl;

/**
 * Defines the methods allowed on forward iterators. A forward iterator allow 
 * multiple passes over the container.
 *
 * <p>Copyright <a href=..\Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */
public interface ForwardIterator extends InputIterator, OutputIterator {

    /**
     * Return the number of times this must be advanced (with next()) in 
     * order to reach target. It is required that both this and target 
     * must point to the same container.
     * @param target the destination iterator.
     */
    public abstract int distance(Iterator target);

    /**
     * Set the position of this iterator to the same position as
     * another iterator. The two iterator must be same, or a casting
     * error occurs.
     */
    public abstract void setTo(Iterator i);
}
