package sjl;

/**
 * An interface for containers that support the <code>push_front()</code> 
 * method. 
 * By implementing this interface, the container can be used with the
 * iterator adapter 
 * <a href=sjl.FrontInsertIterator.html>FrontInsertIterator</a>.
 *
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 *
 * @see FrontInsertIterator
 * @see List
 * @see Deque
 */

public interface FrontInsertContainer extends SequenceContainer {

    /**
     * Add an element to the beginning of the container.
     * @param object The element that will be added to the beginning of the
     *               container.
     */ 
    public abstract void push_front(Object object);

    /**
     * Remove the first element in the container.
     */ 
    public abstract void pop_front();
}
