package sjl;
import java.io.*;

/**
 * A function object that writes objects to a <code>DataOutputStream</code>.
 * A textual representation of the objects is created by calling the 
 * <code>toString()</code> method. 
 * Objects of this class is used by the 
 * <a href=sjl.OutputStreamIterator.html>OutputStreamIterator</a> as the writer
 * object.
 * <pre>
 *     String[] strings = { "apples", "oranges", "bananas" };
 *     Algo.copy(Array.begin(strings), Array.end(strings),
 *             new OutputStreamIterator(System.out, new FuncTextWriter(), "\n");
 * </pre>
 * will print the fruits on the <code>System.out</code> stream.
 *
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncTextWriter implements Function2 {

    /**
     * Write objects to a DataOutputStream.
     * @param o1 The <code>DataOutputStream</code>.
     * @param o2 The object to be written.
     * @return The return value is ignored.
     */
    public Object perform(Object o1, Object o2) {
	DataOutputStream s = (DataOutputStream)o1;
	String str = (o2 == null ? "null" : o2.toString()); 
	try {
            s.writeBytes(str);
	} catch (IOException e) { }
	return null;
    }
}
