package sjl;

class ListIterator extends Iter implements BidirectionalIterator {
    ListNode node;

    public int distance(Iterator end) {
	int n = 0;
	ForwardIterator i = Iter.copy(this);
	while (!i.cmp(end)) {
	    i.next();
	    n++;
	}
	return n;
    }

    public ListIterator(ListNode n) {
	node = n;
    }

    public ListIterator(ListIterator i) {
	node = i.node;
    }

    protected ListIterator _set(ListNode n) {
	node = n;
	return this;
    }

    public Iterator next() {
	node = node.next;
	return this;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Iterator prev()  {
	node = node.prev;
	return this;
    }

    public Object get() {
	return node.data;
    }

    public Object put(Object o) {
	return node.data = o;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public boolean cmp(Iterator i)  {
	return node == ((ListIterator)i).node;
    }

    public ListIterator copy() {
	return new ListIterator(node);
    }

    public Iterator genericCopy() {
	return new ListIterator(node);
    }

    public void setTo(Iterator i) {
	node = ((ListIterator)i).node;
    }
}
