package sjl;
import java.util.Enumeration;

/**
 * <code>MapEnumerator</code> enumerates through the elements of a Map.
 *
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */
class MapEnumerator extends EnumerationIterator {
    boolean keys;

    /**
     * Contruct an Enumeration over the specified range.
     * @param first The beginning of the range.
     * @param last The end of the range.
     */
    public MapEnumerator(ForwardIterator first, ForwardIterator last, boolean keys) {
	super(first, last);
	this.keys = keys;
    }

    /**
     * Returns the next element
     */
    public Object nextElement() {
	Object o = super.nextElement();
	if (keys)
	    return ((Pair)o).first;
	else
	    return ((Pair)o).second;
    }
}
