package sjl;

/**
 * A <code>Pair</code> object can contain two other heterogeneous objects.
 * They are used f.ex. by the <a href=sjl.Map.html>Map</a> container
 * for storing the key and the correspong value.
 */

public class Pair {
    /**
     * The first element of the pair.
     */
    public Object first;

    /**
     * The second element of the pair.
     */
    public Object second;

    /**
     * Construct a new <code>Pair</code>.
     * @param first The first element of the new pair.
     * @param second The second element of the new pair.
     */
    public Pair(Object first, Object second) {
	this.first = first;
	this.second = second;
    }

    /**
     * Return a string representation of this pair.
     */
    public String toString()  {
        StringBuffer buf = new StringBuffer();
        buf.append("Pair<" + first + "," + second + ">");
        return buf.toString();
    }
}
