package sjl;

/**
 * <code>PredEqual</code> is a predicate object designed for 
 * comparing object using the <code>equals()</code> method. 
 * The default implementation compares if the objects are in fact 
 * references to the same object, but all the wrapper classes redefines
 * <code>equals()</code>.
 *
 * <p>Copyright <a href=../..Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredEqual implements Predicate2 {

    /** 
     * Compare the two object using the <code>equals()</code> method.
     * @return The value of equals() is returned.
     */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
    	    return o1.equals(o2);
	}
	return false;
    }
}
