package sjl;

class RBtreeIterator extends Iter implements BidirectionalIterator {
    protected RBtree tree;
    public RBtreeNode node;

    public RBtreeIterator(RBtreeIterator i) {
	tree = i.tree;
	node = i.node;
    }

    public RBtreeIterator(RBtree tree, RBtreeNode node) {
	this.tree = tree;
	this.node = node;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Iterator prev() {
	node = tree._prev(node);
	return this;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Iterator next() {
	node = tree._next(node);
	return this;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Object put(Object value) {
	tree.insert(value);
	return value;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Object get() {
	return node.value;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public boolean cmp(Iterator iterator) {
	return node == ((RBtreeIterator)iterator).node;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Iterator genericCopy() {
	return new RBtreeIterator(tree, node);
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public RBtreeIterator copy() {
	return new RBtreeIterator(tree, node);
    }

    public void setTo(Iterator i) {
        RBtreeIterator ii = (RBtreeIterator)i;
	tree = ii.tree;
	node = ii.node;
    }

    public int distance(Iterator end) {
	int n = 0;
	ForwardIterator i = Iter.copy(this);
	while (!i.cmp(end)) {
	    i.next();
	    n++;
	}
	return n;
    }
}
