package sjl;

/**
 * Defines the methods allowed on all reversible container types. 
 * The supported containers are currently:
 * <code>List</code>, <code>Vector</code>, <code>Array</code>,
 * <code>Set</code>, <code>MultiSet</code>, <code>Map</code> and
 * <code>MultiMap</code>.
 *
 * <p>Copyright <a href=../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 *
 * @see List
 * @see Vector
 * @see Array
 * @see Set
 * @see MultiSet
 * @see Map
 * @see MultiMap
 */
public interface ReversibleContainer {

    /**
     * Return an iterator that points to the beginning of the container. 
     */
    public abstract Iterator rbeginGeneric();

    /**
     * Return an iterator that points past the end of the container. 
     */
    public abstract Iterator rendGeneric();
}
