package sjl;

class SingleListIterator extends Iter implements ForwardIterator {
    SingleListNode node;

    public int distance(Iterator end) {
	int n = 0;
	ForwardIterator i = Iter.copy(this);
	while (!i.cmp(end)) {
	    i.next();
	    n++;
	}
	return n;
    }

    public SingleListIterator(SingleListNode n) {
	node = n;
    }

    public SingleListIterator(SingleListIterator i) {
	node = i.node;
    }

    protected SingleListIterator _set(SingleListNode n) {
	node = n;
	return this;
    }

    public Iterator next() {
	node = node.next;
	return this;
    }

    public Object get() {
	return node.next.data;
    }

    public Object put(Object o) {
	return node.next.data = o;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public boolean cmp(Iterator i)  {
	SingleListIterator ii = (SingleListIterator)i;
	return node.next == ii.node.next;
    }

    public SingleListIterator copy() {
	return new SingleListIterator(node);
    }

    public Iterator genericCopy() {
	return new SingleListIterator(node);
    }

    public void setTo(Iterator i) {
	node = ((SingleListIterator)i).node;
    }

    public String toString() {
	if (node.next == null)
	    return "<null>";
	else
	    return node.toString();
    }
}
