package sjl;

class VectorIterator extends Iter implements RandomIterator {
    Vector vector;
    int pos;

    public int distance(Iterator i) {
	return ((VectorIterator)i).pos - pos;
    }

    public VectorIterator(VectorIterator i) {
	vector = i.vector;
	pos = i.pos;
    }

    public VectorIterator(Vector v, int n) {
	vector = v;
	pos = n;
    }

    public VectorIterator copy() {
	return new VectorIterator(vector, pos);
    }

    public Iterator genericCopy() {
	return new VectorIterator(vector, pos);
    }

    public void setTo(Iterator i) {
        VectorIterator ii = (VectorIterator)i;
	vector = ii.vector;
	pos = ii.pos;
    }

    /**
     * sjl.Iterator stuff
     */
    public boolean cmp(Iterator i)  {
	return pos == ((VectorIterator)i).pos;
    }

    public boolean less(Iterator i) {
	return pos < ((VectorIterator)i).pos;
    }

    public int pos() {
	return pos;
    }

    public void pos(int n) {
	pos = n;
    }

    /**
     * sjl.RandomIterator stuff
     */
    public RandomIterator next(int n)  {
	pos += n;
	return this;
    }

    /**
     * sjl.ForwardIterator stuff
     */
    public Iterator next()  {
	pos++;
	return this;
    }

    /**
     * sjl.RandomIterator stuff
     */
    public RandomIterator prev(int n)  {
	pos -= n;
	return this;
    }

    /**
     * sjl.BidirectionalIterator stuff
     */
    public Iterator prev()  {
	pos--;
	return this;
    }

    /**
     * sjl.RandomIterator stuff
     */
    public Object get(int n)  {
	return vector.data[pos + n];
    }

    /**
     * sjl.InputIterator stuff
     */
    public Object get()  {
	return vector.data[pos];
    }

    /**
     * sjl.RandomIterator stuff
     */
    public Object put(int n, Object o)  {
	return vector.data[pos + n] = o;
    }

    /**
     * sjl.OutputIterator stuff
     */
    public Object put(Object o)  {
	return vector.data[pos] = o;
    }

   public String toString()  {
        StringBuffer buf = new StringBuffer();
        buf.append("vectorIterator[");
        buf.append(pos);
        buf.append("]");
        return buf.toString();
    }
}
