
package sjl.wrappers;
import sjl.Function2;

/**
 * <code>FuncDifferenceFloat</code> is a function object designed for 
 * creating a new object of type <code>Float</code> based on 
 * the two argument objects and the - operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncDifferenceFloat implements Function2 {

    /**
      * Convert the arguments to <code>Float</code> and use the 
      * return values from the <code>floatValue()</code> method 
      * with the <code>-</code> operator to create a new 
      * <code>Float</code> which is returned.
      */
    public Object perform(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
	    return new Float(((Float)o1).floatValue() - ((Float)o2).floatValue());
	}
	return null;
    }
}