
package sjl.wrappers;
import sjl.Function2;

/**
 * <code>FuncDifferenceLong</code> is a function object designed for 
 * creating a new object of type <code>Long</code> based on 
 * the two argument objects and the - operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncDifferenceLong implements Function2 {

    /**
      * Convert the arguments to <code>Long</code> and use the 
      * return values from the <code>longValue()</code> method 
      * with the <code>-</code> operator to create a new 
      * <code>Long</code> which is returned.
      */
    public Object perform(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
	    return new Long(((Long)o1).longValue() - ((Long)o2).longValue());
	}
	return null;
    }
}