
package sjl.wrappers;
import sjl.Function2;

/**
 * <code>FuncModulusInteger</code> is a function object designed for 
 * creating a new object of type <code>Integer</code> based on 
 * the two argument objects and the % operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncModulusInteger implements Function2 {

    /**
      * Convert the arguments to <code>Integer</code> and use the 
      * return values from the <code>intValue()</code> method 
      * with the <code>%</code> operator to create a new 
      * <code>Integer</code> which is returned.
      */
    public Object perform(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
	    return new Integer(((Integer)o1).intValue() % ((Integer)o2).intValue());
	}
	return null;
    }
}