
package sjl.wrappers;
import sjl.Function1;
import java.io.*;

/**
 * <code>FuncReaderString</code> is a function object designed for 
 * reading objects of type <code>String</code> from a DataInputStream.
 * Objects of this class is used by the InputStreamIterator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncReaderString implements Function1 {

    /**
      * Create a object of type <code>String</code> and initialize
      * it with the next String read from the argument stream. The 
      * The <code>readLine()</code> method is called to do the reading.
      * The return value is ignored.
      * @param stream The DataInputStream.
      */
    public Object perform(Object stream) {
	if (stream != null) {
	    DataInputStream s = (DataInputStream)stream;
	    try {
	    	return new String(s.readLine());
	    } catch (IOException e) {}
	}
	return null;
    }
}