
package sjl.wrappers;
import sjl.Function1;
import java.io.*;

/**
 * <code>FuncTextReaderString</code> is a function object designed for 
 * reading objects of type <code>String</code> from a DataInputStream.
 * Each call to this object will read a line from the stream which is then
 * converted into an object of type String.
 * Objects of this class is used by the InputStreamIterator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncTextReaderString implements Function1 {

    /**
      * Create a object of type <code>String</code> and initialize
      * it with the next String read from the argument stream. 
      * An entire line is read in.
      * The return value is ignored.
      * @param stream The DataInputStream.
      */
    public Object perform(Object stream) {
	if (stream != null) {
	    DataInputStream s = (DataInputStream)stream;
	    try {
		String string = s.readLine();
		if (string == null)
		    return null;
		return String.valueOf(string);
	    } catch (IOException e) {}
	}
	return null;
    }
}