
package sjl.wrappers;
import sjl.Function2;
import java.io.*;

/**
 * <code>FuncWriterBoolean</code> is a function object designed for 
 * writing objects type <code>Boolean</code> onto a DataOutputStream.
 * Objects of this class is used by the OutputStreamIterator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class FuncWriterBoolean implements Function2 {

    /**
      * Convert the second argument to <code>Boolean</code> and write
      * it to the <code>DataOutputStream</code> specified by
      * the first argument.  The <code>writeBoolean(Boolean)</code> method is
      * called to do the writing.
      * The return value is ignored.
      * @param stream The DataOutputStream.
      * @param o The object that will be written.
      */
    public Object perform(Object stream, Object o) {
	if (stream != null && o != null) {
	    DataOutputStream s = (DataOutputStream)stream;
	    try {
	    	s.writeBoolean(((Boolean)o).booleanValue());
	    } catch (IOException e) {}
	}
	return null;
    }
}