
package sjl.wrappers;
import sjl.Predicate2;

/**
 * <code>PredGreaterCharacter</code> is a predicate object designed for 
 * comparing objects of type <code>Character</code> for relative ordering using 
 * the &gt operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredGreaterCharacter implements Predicate2 {

    /**
      * Convert the arguments to <code>Character</code> and compare the 
      * return values from the <code>charValue()</code> method using 
      * the <code>&gt</code> operator.
      */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
    	    return ((Character)o1).charValue() > ((Character)o2).charValue();
	}
	return false;
    }
}