
package sjl.wrappers;
import sjl.Predicate2;

/**
 * <code>PredGreaterDouble</code> is a predicate object designed for 
 * comparing objects of type <code>Double</code> for relative ordering using 
 * the &gt operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredGreaterDouble implements Predicate2 {

    /**
      * Convert the arguments to <code>Double</code> and compare the 
      * return values from the <code>doubleValue()</code> method using 
      * the <code>&gt</code> operator.
      */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
    	    return ((Double)o1).doubleValue() > ((Double)o2).doubleValue();
	}
	return false;
    }
}