
package sjl.wrappers;
import sjl.Predicate2;

/**
 * <code>PredLessEqualFloat</code> is a predicate object designed for 
 * comparing objects of type <code>Float</code> for relative ordering using 
 * the &lt= operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredLessEqualFloat implements Predicate2 {

    /**
      * Convert the arguments to <code>Float</code> and compare the 
      * return values from the <code>floatValue()</code> method using 
      * the <code>&lt=</code> operator.
      */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
    	    return ((Float)o1).floatValue() <= ((Float)o2).floatValue();
	}
	return false;
    }
}