
package sjl.wrappers;
import sjl.Predicate2;

/**
 * <code>PredLessEqualInteger</code> is a predicate object designed for 
 * comparing objects of type <code>Integer</code> for relative ordering using 
 * the &lt= operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredLessEqualInteger implements Predicate2 {

    /**
      * Convert the arguments to <code>Integer</code> and compare the 
      * return values from the <code>intValue()</code> method using 
      * the <code>&lt=</code> operator.
      */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
    	    return ((Integer)o1).intValue() <= ((Integer)o2).intValue();
	}
	return false;
    }
}