
package sjl.wrappers;
import sjl.Predicate2;

/**
 * <code>PredLessLong</code> is a predicate object designed for 
 * comparing objects of type <code>Long</code> for relative ordering using 
 * the &lt operator.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredLessLong implements Predicate2 {

    /**
      * Convert the arguments to <code>Long</code> and compare the 
      * return values from the <code>longValue()</code> method using 
      * the <code>&lt</code> operator.
      */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
    	    return ((Long)o1).longValue() < ((Long)o2).longValue();
	}
	return false;
    }
}