
package sjl.wrappers;
import sjl.Predicate2;

/**
 * <code>PredLessString</code> is a predicate object designed for 
 * comparing objects of type <code>String</code> for relative ordering using 
 * the <code>compareTo</code> method.
 *
 * <p>Copyright <a href=../../Copyrght.htm>&copy</a> 1996 Finn Bock<p>
 */

public class PredLessString implements Predicate2 {

    /**
      * Convert the arguments to <code>String</code> and compare the 
      * return value from the <code>compareTo(String)</code> method to 
      * <code>< 0</code>.
      */
    public boolean compare(Object o1, Object o2) {
	if (o1 != null && o2 != null) {
	    return ((String)o1).compareTo(((String)o2)) < 0;
	}
	return false;
    }
}